/*
Plugin Name: WP Social Votes
Plugin URI: http://pervushin.com/wordpress-plugin-social-votes.html
Description: Плагин предназначен для создания онлайн голосования при помощи социальных сетей. В версии 1.0 поддерживается голосование с помощью ВКонтакте, Twitter и Facebook.
Version: 1.0
Author: Сергей Первушин и KOLOS450
Author URI: http://pervushin.com/
*/

jQuery.ajax = (function(_ajax){
    
    var protocol = location.protocol,
        hostname = location.hostname,
        exRegex = RegExp(protocol + '//' + hostname),
        YQL = 'http' + (/^https/.test(protocol)?'s':'') + '://query.yahooapis.com/v1/public/yql?callback=?',
        query = 'select * from html where url="{URL}" and xpath="*"';
    
    function isExternal(url) {
        return !exRegex.test(url) && /:\/\//.test(url);
    }
    
    return function(o) {
        
        var url = o.url;
        
        if ( /get/i.test(o.type) && !/json/i.test(o.dataType) && isExternal(url) ) {
            
            // Manipulate options so that JSONP-x request is made to YQL
            
            o.url = YQL;
            o.dataType = 'json';
            
            o.data = {
                q: query.replace(
                    '{URL}',
                    url + (o.data ?
                        (/\?/.test(url) ? '&' : '?') + jQuery.param(o.data)
                    : '')
                ),
                format: 'xml'
            };
            
            // Since it's a JSONP request
            // complete === success
            if (!o.success && o.complete) {
                o.success = o.complete;
                delete o.complete;
            }
            
            o.success = (function(_success){
                return function(data) {
                    
                    if (_success) {
                        // Fake XHR callback.
                        _success.call(this, {
                            responseText: data.results[0]
                                // YQL screws with <script>s
                                // Get rid of them
                                .replace(/<script[^>]+?\/>|<script(.|\s)*?\/script>/gi, '')
                        }, 'success');
                    }
                    
                };
            })(o.success);
            
        }
        
        return _ajax.apply(this, arguments);
        
    };
    
})(jQuery.ajax);

var sv_current_id = -1;

function sv_vote(id) {
	sv_current_id = id;
	
	jQuery('#sv_dialog').dialog({ 
		modal: true,
		resizable: false,
		width: 350,
		title: 'Голосование'
	});
}

function sv_vote_send(service) {
	var current = sv_data[sv_current_id];
	var url = sv_data['link'] + [sv_current_id] + '/';
	switch(service) {
		case 'fb':
			url = "http://www.facebook.com/sharer.php?s=100&p[title]="+encodeURIComponent(current['name'])+"&p[summary]="+encodeURIComponent(current['description'])+"&p[url]="+encodeURIComponent(url)+"&p[images][0]="+encodeURIComponent(current['image'])+"&nocache-"+randomString(8);
			break;
		case 'tw':
			url = "http://twitter.com/share?text="+encodeURIComponent(current['name'])+" "+current['description']+"&url="+encodeURIComponent(url)+"&counturl="+encodeURIComponent(url)+"&nocache-"+randomString(8);
			break;
		case 'vk':
			url = "http://vkontakte.ru/share.php?title="+encodeURIComponent(current['name'])+"&description="+encodeURIComponent(current['description'])+"&url="+encodeURIComponent(url)+"&image="+encodeURIComponent(current['image']);
			break;
		default:
			return false;
	}
	window.open(url, '', 'toolbar=0,status=0,width=626,height=436');
	jQuery('#sv_dialog').dialog('close');
	return false;
}

function randomString(length) {    
	var chars = '0123456789ABCDEFGHIJKLMNOPQRSTUVWXTZabcdefghiklmnopqrstuvwxyz'.split('');
	if (!length) length = Math.floor(Math.random() * chars.length);
	var str = '';
	for (var i = 0; i < length; i++) {
		str += chars[Math.floor(Math.random() * chars.length)];
	}
	return str;
}

function getCountFb(url, id) {
	var link = 'https://api.facebook.com/method/fql.query?query=select total_count from link_stat where url="' + encodeURIComponent(url) + '"&format=json&callback=?';
	jQuery.getJSON(link, function(data) {
		addCount(id, data[0].total_count);
	});
}

function getCountTw(url, id) {
	var link = 'http://urls.api.twitter.com/1/urls/count.json?url=' + encodeURIComponent(url);
	jQuery.get(link, function(data) {
		var pattern = /count\":(\d+)/gi;
		var res = pattern.exec(data.responseText);
		addCount(id, res[1]);
	});
}

function getCountVk(url, id) {
	var link = 'http://vkontakte.ru/share.php?act=count&index=' + id + '&url=' + encodeURIComponent(url) + '&callback=?';
	jQuery.get(link, function(data) {
		var pattern = /VK\.Share\.count\(\d+, (\d+)\);/gi;
		var res = pattern.exec(data.responseText);
		addCount(id, res[1]);
	});
}

function addCount(id, count) {
	var container = jQuery('#sv_votes_' + id);
	var val = parseInt(container.html(), 10);
	if(!val) val = 0;
	val += parseInt(count);
	container.html(val);
}

jQuery(function() {
	for(var i = 0; i < sv_data['count']; i++) {
		var link = sv_data['link'] + i + '/';
		getCountFb(link, i);
		getCountTw(link, i);
		getCountVk(link, i);
	}
});